package tis4.auth;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.catalina.websocket.WebSocketServlet;

@WebServlet("/Auth")
public class Auth extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see WebSocketServlet#WebSocketServlet()
     */
    public Auth() {
        super();
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    	response.setContentType("text/html");
    	PrintWriter pw = response.getWriter();
    	HttpSession session = request.getSession(true);
    	boolean loggedIn = false;
    	if(session.getAttribute("loggedin")!=null){
    		loggedIn = (boolean)session.getAttribute("loggedin");
    	}
    	if(loggedIn&&request.getParameter("logout")!=null){
    		loggedIn = false;
    		session.setAttribute("loggedin", false);
    		pw.println("Logged out");
    	}
    	if(!loggedIn){
    		printLogin(pw);
    	}else{
	    	pw.println("<html><head><title>Login</title></head><body>");
	    	pw.println("<p>hello "+session.getAttribute("user")+"</p><p><a href=\"Auth?logout=true\">logout</a></p>");
	    	pw.println("<p><a href=\"Auth?getTime=true\">gettime</a></p>");
	    }
    	if(request.getParameter("getTime")!=null){
    		Date d = new Date();
    		pw.println(d.toString());
    	}
    	pw.println("</body></html>");
	}
	private void printLogin(PrintWriter pw){
		pw.println("<html><head><title>Login</title></head><body>");
		pw.println("<form name=\"input\" action=\"Auth\" method=\"post\">" +
				"Username: <input type=\"text\" name=\"user\">" +
				"Password: <input type=\"text\" name=\"pass\">" +
				"<input type=\"submit\" value=\"Submit\"></form></body></html>");
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession(true);
		String user = request.getParameter("user");
		String pass = request.getParameter("pass");
		if(user!=null&&pass!=null){
			session.setAttribute("loggedin", authenticate(user,pass));
			session.setAttribute("user", user);
		}
		doGet(request,response);
	}
	private boolean authenticate(String user, String password){
		if(user.equals("admin")&&password.equals("admin")){
			return true;
		}
		return false;
	}
}
